searchData={"items":[{"type":"module","title":"AshReqOpt","doc":"","ref":"AshReqOpt.html"},{"type":"module","title":"AshReqOpt.ReqOptAttribute","doc":"","ref":"AshReqOpt.ReqOptAttribute.html"},{"type":"function","title":"AshReqOpt.ReqOptAttribute.add_opt/0","doc":"","ref":"AshReqOpt.ReqOptAttribute.html#add_opt/0"},{"type":"function","title":"AshReqOpt.ReqOptAttribute.add_req/0","doc":"","ref":"AshReqOpt.ReqOptAttribute.html#add_req/0"},{"type":"function","title":"AshReqOpt.ReqOptAttribute.opt_transform/1","doc":"","ref":"AshReqOpt.ReqOptAttribute.html#opt_transform/1"},{"type":"function","title":"AshReqOpt.ReqOptAttribute.req_transform/1","doc":"","ref":"AshReqOpt.ReqOptAttribute.html#req_transform/1"},{"type":"module","title":"AshReqOpt.ReqOptBelongsTo","doc":"","ref":"AshReqOpt.ReqOptBelongsTo.html"},{"type":"function","title":"AshReqOpt.ReqOptBelongsTo.add_opt/0","doc":"","ref":"AshReqOpt.ReqOptBelongsTo.html#add_opt/0"},{"type":"function","title":"AshReqOpt.ReqOptBelongsTo.add_req/0","doc":"","ref":"AshReqOpt.ReqOptBelongsTo.html#add_req/0"},{"type":"function","title":"AshReqOpt.ReqOptBelongsTo.transform/2","doc":"","ref":"AshReqOpt.ReqOptBelongsTo.html#transform/2"},{"type":"extras","title":"AshReqOpt","doc":"# AshReqOpt\n\nAn extension library for the Ash framework that provides clearer ways to define required and optional attributes and relationships in your resources.","ref":"readme.html"},{"type":"extras","title":"Features - AshReqOpt","doc":"- Define required/optional attributes using `req` and `opt` macros\n  - Instead of `attribute :email, :string, allow_nil?: false`, use `req :email, :string`\n  - Instead of `attribute :name, :string, allow_nil?: true`, use `opt :name, :string`\n  - You can still use the original `attribute` macro if you prefer\n- Define required/optional relationships using `req_belongs_to` and `opt_belongs_to` macros\n  - Instead of `belongs_to :company, Company, allow_nil?: false`, use `req_belongs_to :company, Company`\n  - Instead of `belongs_to :manager, User, allow_nil?: true`, use `opt_belongs_to :manager, User`\n  - You can still use the original `belongs_to` macro if you prefer\n- Extends Ash resource DSL for more explicit intent","ref":"readme.html#features"},{"type":"extras","title":"Installation - AshReqOpt","doc":"Add `ash_req_opt` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:ash_req_opt, \"~> 0.1.0\"}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Usage Example - AshReqOpt","doc":"```elixir\ndefmodule MyApp.User do\n  use Ash.Resource,\n    extensions: [AshReqOpt]\n\n  attributes do\n    uuid_primary_key :id\n    req :email, :string    # Required attribute (equivalent to allow_nil?: false)\n    opt :name, :string     # Optional attribute (equivalent to allow_nil?: true)\n    attribute :nickname, :string, allow_nil?: true  # Original attribute macro still works\n  end\n\n  relationships do\n    req_belongs_to :company, Company    # Required relationship (equivalent to allow_nil?: false)\n    opt_belongs_to :manager, User       # Optional relationship (equivalent to allow_nil?: true)\n    belongs_to :department, Department, allow_nil?: true  # Original belongs_to macro still works\n  end\nend\n```","ref":"readme.html#usage-example"},{"type":"extras","title":"License - AshReqOpt","doc":"MIT","ref":"readme.html#license"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.38.1"}}